# Generated by Django 2.0 on 2018-07-18 12:32

import arkindex.dataimport.models
from django.conf import settings
import django.contrib.postgres.fields.jsonb
from django.db import migrations, models
import django.db.models.deletion
import enumfields.fields
import uuid


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('documents', '0018_remove_elementlink'),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='DataFile',
            fields=[
                ('id', models.UUIDField(default=uuid.uuid4, primary_key=True, serialize=False)),
                ('name', models.CharField(max_length=100)),
                ('size', models.PositiveIntegerField()),
                ('hash', models.CharField(max_length=32)),
                ('content_type', models.CharField(max_length=50)),
                ('corpus', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='files', to='documents.Corpus')),
            ],
        ),
        migrations.CreateModel(
            name='DataImport',
            fields=[
                ('id', models.UUIDField(default=uuid.uuid4, primary_key=True, serialize=False)),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('updated', models.DateTimeField(auto_now=True)),
                ('state', enumfields.fields.EnumField(default='created', enum=arkindex.dataimport.models.DataImportState, max_length=30)),
                ('mode', enumfields.fields.EnumField(enum=arkindex.dataimport.models.DataImportMode, max_length=30)),
                ('payload', django.contrib.postgres.fields.jsonb.JSONField(blank=True, null=True)),
                ('root_id', models.UUIDField(blank=True, null=True)),
                ('task_count', models.PositiveSmallIntegerField(blank=True, null=True)),
                ('corpus', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='imports', to='documents.Corpus')),
                ('creator', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='imports', to=settings.AUTH_USER_MODEL)),
                ('files', models.ManyToManyField(related_name='imports', to='dataimport.DataFile')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.AlterUniqueTogether(
            name='datafile',
            unique_together={('corpus', 'hash')},
        ),
    ]
