from django.conf.urls import url
from arkindex.dataimport.views import \
    DataImportsList, DataImportCreate, DataImportConfig, DataImportStatus, DataImportFailures, \
    DataFileList, RepositoryList, RepositoryCreate, RepositoryConfig
from arkindex.users.views import CredentialsList, OAuthSignIn, OAuthCallback


urlpatterns = [
    url(r'^$', DataImportsList.as_view(), name='imports'),
    url(r'^new/?$', DataImportCreate.as_view(), name='import-create'),
    url(r'^(?P<pk>[\w\-]+)/config/?$', DataImportConfig.as_view(), name='import-config'),
    url(r'^(?P<pk>[\w\-]+)/status/?$', DataImportStatus.as_view(), name='import-status'),
    url(r'^(?P<pk>[\w\-]+)/failures/?$', DataImportFailures.as_view(), name='import-failures'),
    url(r'^files/?$', DataFileList.as_view(), name='files'),
    url(r'^repos/?$', RepositoryList.as_view(), name='repositories'),
    url(r'^repos/new/?$', RepositoryCreate.as_view(), name='repositories-create'),
    url(r'^repos/(?P<pk>[\w\-]+)/?$', RepositoryConfig.as_view(), name='repositories-config'),
    url(r'^credentials/?$', CredentialsList.as_view(), name='credentials'),
    url(r'^oauth/(?P<provider>\w+)/signin/?$', OAuthSignIn.as_view(), name='oauth-signin'),
    url(r'^oauth/(?P<provider>\w+)/callback/?$', OAuthCallback.as_view(), name='oauth-callback'),
]
