# Generated by Django 2.0 on 2018-06-05 13:37

from django.db import migrations


class Migration(migrations.Migration):

    dependencies = [
        ('documents', '0008_elemntlink_id'),
    ]

    operations = [
        # Drop the existing materialized views
        migrations.RunSQL(
            "drop materialized view if exists elements_parents_cache;",
            reverse_sql="""
            create materialized view elements_parents_cache as
            (
                select * from elements_parents
            );
            """
        ),
        migrations.RunSQL(
            "drop materialized view if exists elements_children_cache;",
            reverse_sql="""
            create materialized view elements_children_cache as
            (
                select * from elements_children
            );
            """
        ),

        # Drop the existing recursive views
        migrations.RunSQL(
            "DROP VIEW IF EXISTS elements_parents;",
            reverse_sql="""
            CREATE OR REPLACE RECURSIVE VIEW elements_parents(id, child_id, parent_id, ordering) AS (
                    SELECT dd.id, ddl.child_id, ddl.parent_id, ddl.order
                    FROM documents_elementlink ddl, documents_element dd
                    WHERE dd.id = ddl.child_id
                UNION
                    SELECT pd.id, ddl.child_id, ddl.parent_id, ddl.order
                    FROM documents_elementlink ddl INNER JOIN elements_parents pd
                    ON pd.parent_id = ddl.child_id
            );
            """
        ),
        migrations.RunSQL(
            "DROP VIEW IF EXISTS elements_children;",
            reverse_sql="""
            CREATE OR REPLACE RECURSIVE VIEW elements_children(id, child_id, parent_id, ordering) AS (
                    SELECT dd.id, ddl.child_id, ddl.parent_id, ddl.order
                    FROM documents_elementlink ddl, documents_element dd
                    WHERE dd.id = ddl.parent_id
                UNION
                    SELECT cd.id, ddl.child_id, ddl.parent_id, ddl.order
                    FROM documents_elementlink ddl INNER JOIN elements_children cd
                    ON cd.child_id = ddl.parent_id
            );
            """
        ),

        # Create the new views
        migrations.RunSQL(
            """
            CREATE OR REPLACE RECURSIVE VIEW elements_parents(id, link_id, child_id, parent_id, ordering) AS (
                    SELECT dd.id, ddl.id AS link_id, ddl.child_id, ddl.parent_id, ddl.order
                    FROM documents_elementlink ddl, documents_element dd
                    WHERE dd.id = ddl.child_id
                UNION
                    SELECT pd.id, ddl.id AS link_id, ddl.child_id, ddl.parent_id, ddl.order
                    FROM documents_elementlink ddl INNER JOIN elements_parents pd
                    ON pd.parent_id = ddl.child_id
            );
            """,
            reverse_sql="DROP VIEW IF EXISTS elements_parents;"
        ),
        migrations.RunSQL(
            """
            CREATE OR REPLACE RECURSIVE VIEW elements_children(id, link_id, child_id, parent_id, ordering) AS (
                    SELECT dd.id, ddl.id AS link_id, ddl.child_id, ddl.parent_id, ddl.order
                    FROM documents_elementlink ddl, documents_element dd
                    WHERE dd.id = ddl.parent_id
                UNION
                    SELECT cd.id, ddl.id AS link_id, ddl.child_id, ddl.parent_id, ddl.order
                    FROM documents_elementlink ddl INNER JOIN elements_children cd
                    ON cd.child_id = ddl.parent_id
            );
            """,
            reverse_sql="DROP VIEW IF EXISTS elements_children;"
        ),

        # Recreate the materialized views
        migrations.RunSQL(
            """
            create materialized view elements_parents_cache as
            (
                select * from elements_parents
            );
            """,
            reverse_sql="drop materialized view if exists elements_parents_cache;"
        ),
        migrations.RunSQL(
            """
            create materialized view elements_children_cache as
            (
                select * from elements_children
            );
            """,
            reverse_sql="drop materialized view if exists elements_children_cache;"
        ),
        migrations.RunSQL(
            """
            create index idx_elements_parents_cache_id on elements_parents_cache (id);
            """,
            reverse_sql="drop index if exists idx_elements_parents_cache_id;"
        ),
        migrations.RunSQL(
            """
            create index idx_elements_parents_cache_parent on elements_parents_cache (parent_id);
            """,
            reverse_sql="drop index if exists idx_elements_parents_cache_parent;"
        ),
        migrations.RunSQL(
            """
            create index idx_elements_children_cache_id on elements_children_cache (id);
            """,
            reverse_sql="drop index if exists idx_elements_children_cache_id;"
        ),
        migrations.RunSQL(
            """
            create index idx_elements_children_cache_child on elements_children_cache (child_id);
            """,
            reverse_sql="drop index if exists idx_elements_children_cache_child;"
        ),
    ]
