from django.conf import settings
from django.conf.urls import url, include
from arkindex.documents.views import \
    VolumesList, VolumePages, VolumeActs, TranscriptionsSearch, ActsSearch


urlpatterns = [

    url(r'^transcriptions/$', TranscriptionsSearch.as_view(), name='transcriptions'),
    url(r'^acts/$', ActsSearch.as_view(), name='acts'),

    # Volumes
    url(r'^volume/(?P<pk>[\w\-]+)/pages/$',
        VolumePages.as_view(), name='volume-pages'),
    url(r'^volume/(?P<pk>[\w\-]+)/acts/$',
        VolumeActs.as_view(), name='volume-acts'),
    url(r'^$', VolumesList.as_view(), name='volumes'),
]

if 'debug_toolbar' in settings.INSTALLED_APPS:
    import debug_toolbar
    urlpatterns = [
        url(r'^__debug__/', include(debug_toolbar.urls)),
    ] + urlpatterns
