from django.core.checks import Error


def api_urls_check(*args, **kwargs):
    '''
    Check that all urls end with a mandatory slash
    '''
    from arkindex.project.api_v1 import api
    return [
        Error(
            'This api url misses a mandatory ending /',
            hint=str(url),
            id='arkindex.E001',
        )
        for url in api
        if not str(url.pattern).endswith('/$')
    ]
