from unittest import TestCase
from django.conf.urls import url
from django.core.checks import Error


class ChecksTestCase(TestCase):

    def test_api_urls_check(self):
        '''
        Check should always be OK
        '''
        from arkindex.project.checks import api_urls_check
        from arkindex.project.api_v1 import api

        self.assertListEqual(api_urls_check(), [])

        # Add an invalid url
        bad_url = url(r'bad', lambda: None, name='bad-url')
        api.append(bad_url)

        # Should trigger the check
        self.assertListEqual(
            api_urls_check(),
            [
                Error(
                    'This api url misses a mandatory ending /',
                    hint=str(bad_url),
                    id='arkindex.E001',
                )
            ]
        )
